require('love.sound')
require('love.audio')
require('love.timer')

notes = {
    vocal = {
	'','',64,'',67,'',69,'',
	-- 1
	'','','','','','','','',64,'',65,'',64,'',67,'','','',64,'','','','','','','','','',64,'',67,'',
	'','',64,'','','','','','','','','',64,'',62,'','','','','','','','','','','','','','','','','',
	'','','','','','','','',64,'',65,'',64,'',67,'','','',64,'','','','','','','','','',64,'',67,'',
	'','',64,'','','','','','','','','',64,'',62,'','','','','','','','','','','','','','','','','',
	-- 2
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','',64,'',67,'',69,'',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 3
	'','','','','','','','',64,'',62,'',60,'',64,'','','','','','','','','',64,'',62,'','','',64,'',
	'','','','','','',62,'',64,'',65,'',64,'',64,'','','',62,'','','',62,'',62,'','','',60,'',60,'',
	'','','','','','','','',64,'',62,'','','',64,'','','','','','','',62,'',64,'',62,'','','',64,'',
	'','','','','','','','',64,'',65,'',64,'',64,'','','',62,'','','','','','','',64,'',67,'',69,'',
	-- 4
	'','','','','','','','',64,'',65,'',64,'',67,'','','',64,'','','','','','','','','',64,'',67,'',
	'','',64,'','','','','','','','','',64,'',62,'','','','','','','','','','','','','','','','','',
	'','','','','','','','',64,'',65,'',64,'',67,'','','',64,'','','','','','','','','',64,'',67,'',
	'','',64,'','','','','','','','','',64,'',62,'','','','','','','','','','','','','','','','','',
	-- 5
	'','','','','','','','',64,'',67,'',69,'',72,'',74,'',76,'',74,'',72,'','','',69,'','','',72,'',
	74,'',76,'',74,'',72,'','','',69,'','','','','',74,'','','','','',72,'','','','','','','','','',
	'','','','','','','','',64,'',67,'',69,'',72,'',74,'',76,'',74,'',72,'','','',69,'','','',72,'',
	74,'',76,'',74,'',72,'','','',69,'','','','','',74,'','','','','',72,'','','','','','','','','',
    },
    synth = {
	'','','','','','','','',
	-- 1
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	72,'',71,'',72,'',69,'',72,'',71,'',72,'',69,'',72,'',71,'',72,'',67,'',72,'',71,'',72,'',67,'',
	71,'',69,'',71,'',67,'',71,'',69,'',71,'',67,'',71,'',69,'',71,'',67,'',71,'',69,'',71,'',67,'',
	-- 2
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 3
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 4
	72,'',71,'',72,'',69,'',72,'',71,'',72,'',69,'',72,'',71,'',72,'',67,'',72,'',71,'',72,'',67,'',
	71,'',69,'',71,'',67,'',71,'',69,'',71,'',67,'',71,'',69,'',71,'',67,'',71,'',69,'',71,'',67,'',
	72,'',71,'',72,'',69,'',72,'',71,'',72,'',69,'',72,'',71,'',72,'',67,'',72,'',71,'',72,'',67,'',
	71,'',69,'',71,'',67,'',71,'',69,'',71,'',67,'',71,'',69,'',71,'',67,'',71,'',69,'',71,'',67,'',
	-- 5
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
    },
    chord1 = {
	'','','','','','','','',
	-- 1
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 2
	76,'','','',76,'','','',76,'','',76,'','',77,'',76,'','','',76,'','','',76,'','',76,'','',77,'',
	76,'','','',76,'','','',76,'','',76,'','',77,'',79,'','','',79,'','','',79,'','',79,'','',79,'',
	76,'','','',76,'','','',76,'','',76,'','',77,'',76,'','','',76,'','','',76,'','',76,'','',77,'',
	76,'','','',76,'','','',76,'','',76,'','',77,'',79,'','','',79,'','','',79,'','',79,'','',79,'',
	-- 3
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 4
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 5
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 6
	76,'','','',76,'','','',76,'','',76,'','',77,'',76,'','','',76,'','','',76,'','',76,'','',77,'',
	76,'','','',76,'','','',76,'','',76,'','',77,'',79,'','','',79,'','','',79,'','',79,'','',79,'',
	76,'','','',76,'','','',76,'','',76,'','',77,'',76,'','','',76,'','','',76,'','',76,'','',77,'',
	76,'','','',76,'','','',76,'','',76,'','',77,'',79,'','','',79,'','','',79,'','',79,'','',79,'',
    },
    chord2 = {
	'','','','','','','','',
	-- 1
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 2
	72,'','','',72,'','','',72,'','',72,'','',72,'',72,'','','',72,'','','',72,'','',72,'','',72,'',
	71,'','','',71,'','','',71,'','',71,'','',71,'',71,'','','',71,'','','',71,'','',71,'','',71,'',
	72,'','','',72,'','','',72,'','',72,'','',72,'',72,'','','',72,'','','',72,'','',72,'','',72,'',
	71,'','','',71,'','','',71,'','',71,'','',71,'',71,'','','',71,'','','',71,'','',71,'','',71,'',
	-- 3
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 4
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 5
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 6
	72,'','','',72,'','','',72,'','',72,'','',72,'',72,'','','',72,'','','',72,'','',72,'','',72,'',
	71,'','','',71,'','','',71,'','',71,'','',71,'',71,'','','',71,'','','',71,'','',71,'','',71,'',
	72,'','','',72,'','','',72,'','',72,'','',72,'',72,'','','',72,'','','',72,'','',72,'','',72,'',
	71,'','','',71,'','','',71,'','',71,'','',71,'',71,'','','',71,'','','',71,'','',71,'','',71,'',
    },
    chord3 = {
	'','','','','','','','',
	-- 1
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 2
	69,'','','',69,'','','',69,'',69,69,'',69,'','',67,'','','',67,'','','',67,'',67,67,'',67,67,'',
	67,'','','',67,'','','',67,'',67,67,'',67,67,'',67,'','','',67,'','','',67,'',67,67,'',67,'','',
	69,'','','',69,'','','',69,'',69,69,'',69,'','',67,'','','',67,'','','',67,'',67,67,'',67,67,'',
	67,'','','',67,'','','',67,'',67,67,'',67,67,'',67,'','','',67,'','','',67,'',67,67,'',67,'','',
	-- 3
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 4
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 5
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 6
	69,'','','',69,'','','',69,'',69,69,'',69,'','',67,'','','',67,'','','',67,'',67,67,'',67,67,'',
	67,'','','',67,'','','',67,'',67,67,'',67,67,'',67,'','','',67,'','','',67,'',67,67,'',67,'','',
	69,'','','',69,'','','',69,'',69,69,'',69,'','',67,'','','',67,'','','',67,'',67,67,'',67,67,'',
	67,'','','',67,'','','',67,'',67,67,'',67,67,'',67,'','','',67,'','','',67,'',67,67,'',67,'','',
    },
    bass = {
	'','','','','','','','',
	-- 1
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
	-- 2
	45,'','','',45,'','',45,'','',45,'','','',43,'',48,'','','',48,'','',48,'','',50,'','','',52,'',
	52,'','','',52,'','',52,'','',52,'','','',52,'',55,'','','',55,'','',55,'','',52,'','','',55,'',
	45,'','','',45,'','',45,'','',45,'','','',43,'',48,'','','',48,'','',48,'','',50,'','','',52,'',
	52,'','','',52,'','',52,'','',52,'','','',52,'',55,'','','',55,'','',55,'','',52,'','','',55,'',
	-- 3
	45,'','','',45,'','',45,'','',45,'','','',43,'',48,'','','',48,'','',48,'','',50,'','','',52,'',
	52,'','','',52,'','',52,'','',52,'','','',52,'',55,'','','',55,'','',55,'','',52,'','','',55,'',
	45,'','','',45,'','',45,'','',45,'','','',43,'',48,'','','',48,'','',48,'','',50,'','','',52,'',
	52,'','','',52,'','',52,'','',52,'','','',52,'',55,'','','',55,'','',55,'','',52,'','','',55,'',
	-- 4
	45,'','','',45,'','',45,'','',45,'','','',43,'',48,'','','',48,'','',48,'','',50,'','','',52,'',
	52,'','','',52,'','',52,'','',52,'','','',52,'',55,'','','',55,'','',55,'','',52,'','','',55,'',
	45,'','','',45,'','',45,'','',45,'','','',43,'',48,'','','',48,'','',48,'','',50,'','','',52,'',
	52,'','','',52,'','',52,'','',52,'','','',52,'',55,'','','',55,'','',55,'','',52,'','','',55,'',
	-- 5
	45,'','','',45,'','',45,'','',45,'','','',43,'',48,'','','',48,'','',48,'','',50,'','','',52,'',
	52,'','','',52,'','',52,'','',52,'','','',52,'',55,'','','',55,'','',55,'','',52,'','','',55,'',
	45,'','','',45,'','',45,'','',45,'','','',43,'',48,'','','',48,'','',48,'','',50,'','','',52,'',
	52,'','','',52,'','',52,'','',52,'','','',52,'',55,'','','',55,'','',55,'','',52,'','','',55,'',
	-- 6
	45,'','','',45,'','',45,'','',45,'','','',43,'',48,'','','',48,'','',48,'','',50,'','','',52,'',
	52,'','','',52,'','',52,'','',52,'','','',52,'',55,'','','',55,'','',55,'','',52,'','','',55,'',
	45,'','','',45,'','',45,'','',45,'','','',43,'',48,'','','',48,'','',48,'','',50,'','','',52,'',
	52,'','','',52,'','',52,'','',52,'','','',52,'',55,'','','',55,'','',55,'','',52,'','','',55,'',
    }
}
    
note = 1

channel = love.thread.getChannel('')

timer = 0

while true do
    sounddata = channel:pop()
    if sounddata then
	sources = {}
	for k, v in pairs(notes) do
	    sources[k] = love.audio.newSource(sounddata)
	end
	playing = true
	lastTime = love.timer.getTime()
    end

    if playing then
	timer = timer + love.timer.getTime() - lastTime

	local limit = 0.12
	if timer > limit then
	    timer = timer - limit

	    local toPlay = {}

	    function f(t, v, n)
		if type(notes[t][note]) == 'number' then
		    local s = sources[t]
		    s:setPitch(1.05946^(notes[t][note]-66+(12 * (n or 0))))
		    s:setVolume(v or 1)
		    table.insert(toPlay, s)
		end
	    end

	    f('vocal')
	    f('synth', .4)
	    f('chord1', .5)
	    f('chord2', .5)
	    f('chord3', .5)
	    f('bass', .4, 1)

	    love.audio.stop(toPlay)
	    love.audio.play(toPlay)

	    note = note + 1

	    if note == 12 * 64 + 8 then
		note = 4 * 64 + 8
	    end
	end

	lastTime = love.timer.getTime()
    end

    love.timer.sleep(0.001)
end
